from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String

Dcmqrscp_V0_1_0 = CommandToolBuilder(tool="dcmqrscp", base_command=["dcmqrscp"], inputs=[ToolInput(tag="in_arguments", input_type=Boolean(optional=True), prefix="--arguments", doc=InputDocumentation(doc="print expanded command line arguments")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="quiet mode, print no warnings and errors")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="verbose mode, print processing details")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="debug mode, print debug information")), ToolInput(tag="in_log_level", input_type=Boolean(optional=True), prefix="--log-level", doc=InputDocumentation(doc="[l]evel: string constant\n(fatal, error, warn, info, debug, trace)\nuse level l for the logger")), ToolInput(tag="in_log_config", input_type=Boolean(optional=True), prefix="--log-config", doc=InputDocumentation(doc="[f]ilename: string\nuse config file f for the logger")), ToolInput(tag="in_config", input_type=Boolean(optional=True), prefix="--config", doc=InputDocumentation(doc="[f]ilename: string\nuse specific configuration file\n(default: /usr/local/etc/dcmtk/dcmqrscp.cfg)")), ToolInput(tag="in_single_process", input_type=Boolean(optional=True), prefix="--single-process", doc=InputDocumentation(doc="single process mode")), ToolInput(tag="in_fork", input_type=Boolean(optional=True), prefix="--fork", doc=InputDocumentation(doc="fork child process for each assoc. (default)")), ToolInput(tag="in_require_find", input_type=Boolean(optional=True), prefix="--require-find", doc=InputDocumentation(doc="reject all MOVE/GET presentation contexts for\nwhich no correspond. FIND context is proposed")), ToolInput(tag="in_no_parallel_store", input_type=Boolean(optional=True), prefix="--no-parallel-store", doc=InputDocumentation(doc="reject multiple simultaneous STORE presentat.\ncontexts for one application entity title")), ToolInput(tag="in_disable_get", input_type=Boolean(optional=True), prefix="--disable-get", doc=InputDocumentation(doc="disable C-GET support")), ToolInput(tag="in_allow_shutdown", input_type=Boolean(optional=True), prefix="--allow-shutdown", doc=InputDocumentation(doc="allow external shutdown via private SOP class")), ToolInput(tag="in_check_find", input_type=Boolean(optional=True), prefix="--check-find", doc=InputDocumentation(doc="check C-FIND identifier validity")), ToolInput(tag="in_no_check_find", input_type=Boolean(optional=True), prefix="--no-check-find", doc=InputDocumentation(doc="do not check C-FIND identifier validity (def.)")), ToolInput(tag="in_check_move", input_type=Boolean(optional=True), prefix="--check-move", doc=InputDocumentation(doc="check C-MOVE identifier validity")), ToolInput(tag="in_no_check_move", input_type=Boolean(optional=True), prefix="--no-check-move", doc=InputDocumentation(doc="do not check C-MOVE identifier validity (def.)")), ToolInput(tag="in_move_unrestricted", input_type=Boolean(optional=True), prefix="--move-unrestricted", doc=InputDocumentation(doc="do not restrict move destination (default)")), ToolInput(tag="in_move_ae_title", input_type=Boolean(optional=True), prefix="--move-aetitle", doc=InputDocumentation(doc="restrict move dest. to requesting AE title")), ToolInput(tag="in_move_host", input_type=Boolean(optional=True), prefix="--move-host", doc=InputDocumentation(doc="restrict move destination to requesting host")), ToolInput(tag="in_move_vendor", input_type=Boolean(optional=True), prefix="--move-vendor", doc=InputDocumentation(doc="restrict move destination to requesting vendor")), ToolInput(tag="in_no_patient_root", input_type=Boolean(optional=True), prefix="--no-patient-root", doc=InputDocumentation(doc="do not support Patient Root Q/R models")), ToolInput(tag="in_no_study_root", input_type=Boolean(optional=True), prefix="--no-study-root", doc=InputDocumentation(doc="do not support Study Root Q/R models")), ToolInput(tag="in_no_patient_study", input_type=Boolean(optional=True), prefix="--no-patient-study", doc=InputDocumentation(doc="do not support Patient/Study Only Q/R models")), ToolInput(tag="in__proposeuncompr_propose", input_type=Boolean(optional=True), prefix="-x", doc=InputDocumentation(doc="=   --propose-uncompr       propose all uncompressed TS, explicit VR\nwith local byte ordering first (default)")), ToolInput(tag="in_propose_little", input_type=Boolean(optional=True), prefix="--propose-little", doc=InputDocumentation(doc="propose all uncompressed TS, explicit VR\nlittle endian first")), ToolInput(tag="in_propose_big", input_type=Boolean(optional=True), prefix="--propose-big", doc=InputDocumentation(doc="propose all uncompressed TS, explicit VR\nbig endian first")), ToolInput(tag="in_propose_implicit", input_type=Boolean(optional=True), prefix="--propose-implicit", doc=InputDocumentation(doc="propose implicit VR little endian TS only")), ToolInput(tag="in_propose_lossless", input_type=Boolean(optional=True), prefix="--propose-lossless", doc=InputDocumentation(doc="propose default JPEG lossless TS\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_jpeg_eight", input_type=Boolean(optional=True), prefix="--propose-jpeg8", doc=InputDocumentation(doc="propose default JPEG lossy TS for 8 bit data\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_jpeg_one_two", input_type=Boolean(optional=True), prefix="--propose-jpeg12", doc=InputDocumentation(doc="propose default JPEG lossy TS for 12 bit data\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_j_two_k_lossless", input_type=Boolean(optional=True), prefix="--propose-j2k-lossless", doc=InputDocumentation(doc="propose JPEG 2000 lossless TS\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_j_two_k_lossy", input_type=Boolean(optional=True), prefix="--propose-j2k-lossy", doc=InputDocumentation(doc="propose JPEG 2000 lossy TS\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_jls_lossless", input_type=Boolean(optional=True), prefix="--propose-jls-lossless", doc=InputDocumentation(doc="propose JPEG-LS lossless TS\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_jls_lossy", input_type=Boolean(optional=True), prefix="--propose-jls-lossy", doc=InputDocumentation(doc="propose JPEG-LS lossy TS\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_mpeg_two", input_type=Boolean(optional=True), prefix="--propose-mpeg2", doc=InputDocumentation(doc="propose MPEG2 Main Profile @ Main Level TS only")), ToolInput(tag="in_propose_mpeg_two_high", input_type=Boolean(optional=True), prefix="--propose-mpeg2-high", doc=InputDocumentation(doc="propose MPEG2 Main Profile @ High Level TS only")), ToolInput(tag="in_propose_mpeg_four", input_type=Boolean(optional=True), prefix="--propose-mpeg4", doc=InputDocumentation(doc="propose MPEG4 AVC/H.264 HP / Level 4.1 TS only")), ToolInput(tag="in_propose_mpeg_four_bd", input_type=Boolean(optional=True), prefix="--propose-mpeg4-bd", doc=InputDocumentation(doc="propose MPEG4 AVC/H.264 BD-compatible TS only")), ToolInput(tag="in_propose_rle", input_type=Boolean(optional=True), prefix="--propose-rle", doc=InputDocumentation(doc="propose RLE lossless TS\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_propose_deflated", input_type=Boolean(optional=True), prefix="--propose-deflated", doc=InputDocumentation(doc="propose deflated expl. VR little endian TS\nand all uncompressed transfer syntaxes")), ToolInput(tag="in_timeout", input_type=Boolean(optional=True), prefix="--timeout", doc=InputDocumentation(doc="[s]econds: integer (default: unlimited)\ntimeout for connection requests")), ToolInput(tag="in_acse_timeout", input_type=Boolean(optional=True), prefix="--acse-timeout", doc=InputDocumentation(doc="[s]econds: integer (default: 30)\ntimeout for ACSE messages")), ToolInput(tag="in_dim_se_timeout", input_type=Boolean(optional=True), prefix="--dimse-timeout", doc=InputDocumentation(doc="[s]econds: integer (default: unlimited)\ntimeout for DIMSE messages")), ToolInput(tag="in_max_pdu", input_type=Boolean(optional=True), prefix="--max-pdu", doc=InputDocumentation(doc="[n]umber of bytes: integer (4096..131072)\nset max receive pdu to n bytes\n(default: use value from configuration file)")), ToolInput(tag="in_disable_host_lookup", input_type=Boolean(optional=True), prefix="--disable-host-lookup", doc=InputDocumentation(doc="disable hostname lookup")), ToolInput(tag="in_refuse", input_type=Boolean(optional=True), prefix="--refuse", doc=InputDocumentation(doc="refuse association")), ToolInput(tag="in_reject", input_type=Boolean(optional=True), prefix="--reject", doc=InputDocumentation(doc="reject association if no implement. class UID")), ToolInput(tag="in_ignore", input_type=Boolean(optional=True), prefix="--ignore", doc=InputDocumentation(doc="ignore store data, receive but do not store")), ToolInput(tag="in_uid_padding", input_type=Boolean(optional=True), prefix="--uid-padding", doc=InputDocumentation(doc="silently correct space-padded UIDs")), ToolInput(tag="in_disable_new_vr", input_type=Boolean(optional=True), prefix="--disable-new-vr", doc=InputDocumentation(doc="disable support for new VRs, convert to OB")), ToolInput(tag="in_normal", input_type=Boolean(optional=True), prefix="--normal", doc=InputDocumentation(doc="allow implicit format conversions (default)")), ToolInput(tag="in_write_dataset", input_type=Boolean(optional=True), prefix="--write-dataset", doc=InputDocumentation(doc="write data set without file meta information")), ToolInput(tag="in_group_length_remove", input_type=Boolean(optional=True), prefix="--group-length-remove", doc=InputDocumentation(doc="always write without group length elements")), ToolInput(tag="in_length_undefined", input_type=Boolean(optional=True), prefix="--length-undefined", doc=InputDocumentation(doc="write with undefined lengths")), ToolInput(tag="in_padding_off", input_type=Boolean(optional=True), prefix="--padding-off", doc=InputDocumentation(doc="no padding (default)")), ToolInput(tag="in_port", input_type=String(), position=0, doc=InputDocumentation(doc="tcp/ip port number to listen on\n(default: in config file)"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Dcmqrscp_V0_1_0().translate("wdl", allow_empty_container=True)

